-- name: [CS] Beebo
-- description: Your average "Yeah, okay, fine." Type robot. Doesn't know much about the world, but also doesn't really care.\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here works >v<
	(This is an edited version of the Template File by Squishy)
]]

local TEXT_MOD_NAME = "Beebo"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_CUSTOM_MODEL = smlua_model_util_get_id("beebo_geo") -- Located in "actors"

local TEX_CUSTOM_LIFE_ICON = get_texture_info("beebo") -- Located in "textures"
local TEX_CUSTOM_STAR_ICON = get_texture_info("icecream")


-- All Located in "sound" Name them whatever you want. Remember to include the .ogg extension
local VOICETABLE_CHARNAME2 = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'startup.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'startup.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Jump2.ogg', 'Jump1.ogg', 'Jump2.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'JumpVoiced1.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'JumpVoiced2.ogg', 'JumpVoiced3.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'smack.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'Silent.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'smack.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'Pole.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Silent.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'beebofall.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'boing.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'Pole.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'jingle.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'sologbowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Damage.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'FireScream.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'tired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'yawn.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'snore.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'coughh.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'DEATH.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'drown.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'huh.ogg' -- Booted out of level
}

-- All Located in "actors"
local CAPTABLE_CHAR = {
    normal = smlua_model_util_get_id("battery_geo"),
    wing = smlua_model_util_get_id("batterywing_geo"),
    metal = smlua_model_util_get_id("batterymetal_geo"),
}

local E_MODEL_CUSTOM_STAR = smlua_model_util_get_id("icecream_geo")

local PALETTE_CHAR = {
    [PANTS]  = "3129CEFF",
    [SHIRT]  = "4C4CFFFF",
    [GLOVES] = "ffffff",
    [SHOES]  = "7CFF81FF",
    [HAIR]   = "ffffff",
    [SKIN]   = "91A1FFFF",
    [CAP]    = "7CFF81FF",
	[EMBLEM] = "7CFF81FF"
}

local HM_CHARNAME2= {
    label = {
        left = get_texture_info("BLeftHealth"),
        right = get_texture_info("BRightHealth"),
    },
    pie = {
        [1] = get_texture_info("Pie1"),
        [2] = get_texture_info("Pie2"),
        [3] = get_texture_info("Pie3"),
        [4] = get_texture_info("Pie4"),
        [5] = get_texture_info("Pie5"),
        [6] = get_texture_info("Pie6"),
        [7] = get_texture_info("Pie7"),
        [8] = get_texture_info("Pie8"),
    }
}

local CSloaded = false
local function on_character_select_load()
    CT_CHARNAME2 = _G.charSelect.character_add("Beebo", {"Your average: \"Yeah, okay, fine.\" Type robot." , "Doesn't know much about the world," , "but also doesn't really care.", " ", "- Degnut"}, "Loader / Marinezu - Texturing / Robotomy and zKevin- SFX", {r = 124, g = 255, b = 129}, E_MODEL_CUSTOM_MODEL, CT_CHARNAME2, TEX_CUSTOM_LIFE_ICON)
    _G.charSelect.character_add_caps(E_MODEL_CUSTOM_MODEL, CAPTABLE_CHAR)
    _G.charSelect.character_add_voice(E_MODEL_CUSTOM_MODEL, VOICETABLE_CHARNAME2)
    _G.charSelect.character_add_celebration_star(E_MODEL_CUSTOM_MODEL, E_MODEL_CUSTOM_STAR, TEX_CUSTOM_STAR_ICON)
    _G.charSelect.character_add_palette_preset(E_MODEL_CUSTOM_MODEL, PALETTE_CHAR)
    _G.charSelect.character_add_health_meter(CT_CHARNAME2, HM_CHARNAME2)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CHARNAME2 then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_CHARNAME2 then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)

local m = gMarioStates[0]

function mario_update(m)
    if CT_CHARNAME2 == _G.charSelect.character_get_current_number() then
      if (m.action == ACT_STAR_DANCE_EXIT) then
          m.marioBodyState.eyeState = MARIO_EYES_LOOK_LEFT
      end
    end
 end

 hook_event(HOOK_MARIO_UPDATE, mario_update)